#include <stdio.h>

#include "tracker.h"

int loadfile() {
	FILE *f;
	char buf[1024];
	int p[8];
	
	f = fopen(filename, "r");
	if(!f) {
		return 1;
	}

	while(fgets(buf, sizeof(buf), f)) {
		if(4 == sscanf(buf, "se %x %x %x %x", &p[0], &p[1], &p[2], &p[3])) {
			song.line[p[0]].track[p[1]] = p[2];
			song.line[p[0]].transp[p[1]] = p[3];
			if(p[0] >= song.length) song.length = p[0] + 1;
		} else if(4 == sscanf(buf, "tl %x %x %x %x", &p[0], &p[1], &p[2], &p[3])) {
			track[p[0]].line[p[1]].note = p[2];
			track[p[0]].line[p[1]].instr = p[3];
		} else if(3 == sscanf(buf, "il %x %x %x", &p[0], &p[1], &p[2])) {
			instrument[p[0]].line[p[1]] = p[2];
			if(instrument[p[0]].length <= p[1]) instrument[p[0]].length = p[1] + 1;
		}
	}

	fclose(f);

	return 0;
}

int savefile() {
	FILE *f;
	int i, j;
	int any;

	f = fopen(filename, "w");
	if(!f) {
		return 1;
	}

	fprintf(f, "propdemo\n\n");

	for(i = 0; i < song.length; i++) {
		for(j = 0; j < 8; j++) {
			fprintf(f, "se %02x %02x %02x %02x\n",
				i,
				j,
				song.line[i].track[j],
				song.line[i].transp[j]);
		}
		fprintf(f, "\n");
	}

	for(i = 1; i < MAXTRACK; i++) {
		any = 0;
		for(j = 0; j < TRACKLEN; j++) {
			u8 note = track[i].line[j].note;
			u8 instr = track[i].line[j].instr;
			if(note || instr) {
				fprintf(f, "tl %02x %02x %02x %02x\n", i, j, note, instr);
				any = 1;
			}
		}
		if(any) fprintf(f, "\n");
	}

	for(i = 1; i < MAXINSTR; i++) {
		any = 0;
		for(j = 0; j < instrument[i].length; j++) {
			fprintf(f, "il %02x %02x %04x\n", i, j, instrument[i].line[j]);
			any = 1;
		}
		if(any && i != MAXINSTR - 1) fprintf(f, "\n");
	}

	fclose(f);

	return 0;
}
