			include "propeller.i"
			include "demo.i"

			org	0
FOTIME			=	520
FOTIME_SL		=	50

			mov	t1, #DITHER_HALF
			wrbyte	t1, =@ditherstyle
			wrlong	frontback, =@backbuf

loop
			add	frame, #1
			add	angframe, #3

			mov	fade, #$30
			sub	fade, frame
			mins	fade, #0

			mov	t1, frame
			mov	0, PAR		nr wz
		if_z	sub	t1, =FOTIME	wc
		if_nz	sub	t1, =FOTIME_SL	wc
		if_nc	mov	fade, t1
		if_nc	shr	fade, #2
			max	fade, #$30

			mov	addr, frontback
			add	addr, #28

			mov	ycount, #64
yloop
			mov	xcount, #64
xloop
			mov	x, xcount
			sub	x, #32
			mov	y, ycount
			sub	y, #32

			abs	mulu_x, x
			mov	mulu_s, mulu_x
			call	#mulu
			mov	r, mulu_s
			abs	mulu_x, y
			mov	mulu_s, mulu_x
			call	#mulu
			add	r, mulu_s
			shr	r, #4

			abs	absy, y

			mov	divu_n, x	wc
			sumnc	divu_n, absy
			mov	divu_d, absy
			sumc	divu_d, x

			mov	t1, =1 << 5
		if_c	add	t1, =1 << 6

			abs	divu_n, divu_n	wc
			rcl	signed, #1
			abs	divu_d, divu_d	wc
		if_c	xor	signed, #1

			shl	divu_n, #5	' angular scale
			call	#divu

			shr	signed, #1	wc
			sumnc	t1, divu_n

			mov	y, y		wc
			negc	t1, t1

			mov	t2, t1
			shr	t2, #1
			add	t1, t2

			add	t1, angframe
			add	t1, r

			and	t1, #$3f
			max	t1, #$30
			sub	t1, r
			sub	t1, fade
			mins	t1, #0

			wrbyte	t1, addr
			add	addr, #1
			djnz	xcount, #xloop

			add	addr, #64
			djnz	ycount, #yloop

			' swap buffers
			rol	frontback, #16
			wrlong	frontback, =@backbuf
			wrbyte	zero, =@internalvbl
:wvbl			rdbyte	t1, =@internalvbl
			tjz	t1, #:wvbl

			jmp	#loop

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[15..0]
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1
			shr	mulu_s, #8
mulu_ret		ret

divu			shl	divu_d, #7
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, #255
divu_ret		ret

frontback		word	@graphics0h, @graphics1h

			pool

angframe		long	0
frame			long	0

t1			res	1
t2			res	1
addr			res	1
ycount			res	1
xcount			res	1
x			res	1
y			res	1
absy			res	1
r			res	1
fade			res	1

divu_n			res	1
divu_d			res	1
signed			res	1

mulu_x			res	1
mulu_s			res	1
