			include "propeller.i"
			include "demo.i"

			org	0
GROWTIME		=	280
FALLTIME		=	720
FADETIME		=	2

			mov	t1, #DITHER_8
			wrbyte	t1, =@ditherstyle
			wrlong	frontback, =@backbuf
loop
			add	frame, #25
			cmp	frame, =GROWTIME * 25		wc wz
		if_ae	add	grow, #1
			add	wobble, #38

			add	fade, #1
			max	fade, =32 << FADETIME

			mov	fall, frame
			sub	fall, =FALLTIME * 25
			mins	fall, #0
			shr	fall, #8
			sub	fade, fall
			mins	fade, #0

			mov	cmd, #RAST_CLEAR
			call	#rastercall

			mov	sin_a, wobble
			call	#sin
			negnz	cp + 0, mulu_x
			sar	cp + 0, #5
			add	cp + 0, =60 << 8

			mov	sin_a, wobble
			add	sin_a, frame
			call	#cos
			negnz	cp + 1, mulu_x
			sar	cp + 1, #5
			add	cp + 1, =58 << 8

			mov	arm, =(1 << 13) - 1
			mov	fr, frame
:lp
			shr	fr, #1
			add	fr, =1 << 12
			mov	t1, frame
			shr	t1, #1
			add	fr, t1

			call	#drawarm

			sub	arm, =(1 << 13)/6	wc
		if_nc	jmp	#:lp

			call	#waitraster

			' swap buffers
			rol	frontback, #16
			wrlong	frontback, =@backbuf
			wrbyte	zero, =@internalvbl
:wvbl			rdbyte	t1, =@internalvbl
			tjz	t1, #:wvbl

			jmp	#loop

drawarm
			mov	r, grow
			max	r, #45
			mov	sin_a, frame
			add	sin_a, arm

			call	#sin
			mov	mulu_s, r
			call	#mulu
			shr	mulu_s, #8
			negnz	cp + 3, mulu_s
			call	#cos
			mov	mulu_s, r
			call	#mulu
			shr	mulu_s, #8
			negnz	cp + 2, mulu_s

			add	cp + 2, =60 << 8
			add	cp + 3, =58 << 8

			mov	r, grow
			shr	r, #1
			max	r, #40
			neg	sin_a, fr

			call	#sin
			mov	mulu_s, r
			call	#mulu
			shr	mulu_s, #8
			negnz	cp + 5, mulu_s
			add	sin_a, arm
			call	#cos
			mov	mulu_s, r
			call	#mulu
			shr	mulu_s, #8
			negnz	cp + 4, mulu_s

			add	cp + 4, =60 << 8
			add	cp + 5, =58 << 8

			' World coordinates in cp[0..5] (three pairs of x, y in 8.8 format)

			mov	t, fade			wz
		if_z	jmp	drawarm_ret
			shr	t, #FADETIME
			mov	stride, =5 << 14
			movs	:w0, #weights0
			movs	:w1, #weights1
			movs	:w0r, #weights0 + 31
:lp
			' x(t) = w0(t) * cp(0) + w1(t) * cp(1) + w0(n-t-1) * cp(2)

:w0			mov	weight, 000
			mov	mulu_x, cp+0
			mov	mulu_s, weight
			call	#mulu
			mov	x, mulu_s
			mov	mulu_x, cp+1
			mov	mulu_s, weight
			call	#mulu
			mov	y, mulu_s

:w1			mov	weight, 000
			mov	mulu_x, cp+2
			mov	mulu_s, weight
			call	#mulu
			add	x, mulu_s
			mov	mulu_x, cp+3
			mov	mulu_s, weight
			call	#mulu
			add	y, mulu_s

:w0r			mov	weight, 000
			mov	mulu_x, cp+4
			mov	mulu_s, weight
			call	#mulu
			add	x, mulu_s
			mov	mulu_x, cp+5
			mov	mulu_s, weight
			call	#mulu
			add	y, mulu_s

			shr	y, #16

			cmps	y, =108		wc wz
		if_ae	jmp	#:clip

			shr	x, #16
			shl	y, #7
			add	y, x
			add	y, frontback

			call	#waitraster
			wrword	y, =@rast_dest
			mov	cmd, #RAST_BLENDTEX
			wrlong	stride, =@rast_stride
			call	#rastercall
:clip
			add	stride, =1 << 11
			add	:w0, #1
			add	:w1, #1
			sub	:w0r, #1

			djnz	t, #:lp

drawarm_ret		ret

waitraster
:wait			rdbyte	t1, =@rastercmd
			tjnz	t1, #:wait
waitraster_ret		ret

rastercall
			call	#waitraster
			wrbyte	cmd, =@rastercmd
rastercall_ret		ret

			' |sin(sin_a[12..0])| -> sin_a[15..0], (sin(sin_a[12..0]) >= 0) -> z

cos			add	sin_a, =$0800
sin			mov	sin_addr, sin_a
			test	sin_addr, =$0800	wc
			test	sin_addr, =$1000	wz
			and	sin_addr, =$07ff
		if_c	xor	sin_addr, =$07ff
			shl	sin_addr, #1
			or	sin_addr, =$e000
			rdword	mulu_x, sin_addr
cos_ret
sin_ret			ret

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

frontback		word	@graphics0, @graphics1

			pool

			' bezier tables

weights0		long	255, 239, 223, 208, 193, 179, 166, 153, 140, 128, 117, 106, 96, 86, 77, 68
			long	60, 52, 45, 38, 32, 27, 21, 17, 13, 10, 7, 4, 2, 1, 0, 0
weights1		long	0, 16, 31, 45, 57, 69, 80, 89, 98, 105, 111, 117, 121, 124, 126, 127
			long	127, 126, 124, 121, 117, 111, 105, 98, 89, 80, 69, 57, 45, 31, 16, 0

fade			long	(1 << FADETIME) - 1
grow			long	16
frame			long	0
wobble			long	0

t1			res	1
cmd			res	1

arm			res	1
fr			res	1
fall			res	1

x			res	1
y			res	1
r			res	1
t			res	1
weight			res	1
stride			res	1

sin_a			res	1
sin_addr		res	1
mulu_s			res	1
mulu_x			res	1

cp			res	6

			vfit	496
