
			include "propeller.i"
			include "demo.i"

			org	0

			long	3[256]

codestart
			mov	0, PAR		wz nr
		if_nz	sub	p_pre, #2
		if_nz	add	p_post, #2
			rdlong	sync, =@nextvbl

			waitcnt	sync, =$14000		' Sync cogs, add 1 ms to sync variable

			' Set up vga video on P16-P23

			movi	FRQA, #$10000000 >> 23
			mov	DIRA, =$00ff_0100
			mov	VSCL, #1
			mov	VCFG, =%0_01_1_00_000_00000000000_010_0_11111111

			' Enable PLLs simultaneously in both cogs

			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			waitcnt	sync, =84230			' Wait for PLL stabilization
			mov	VSCL, vscl_bporch

field
			add	sync, =2540*525
			wrlong	sync, =@nextvbl

			mov	VSCL, vscl_hsync	' hsync + front porch, vsync held low
			waitvid	metapixels, #%%1133
			mov	VSCL, vscl_blank
			waitvid	metapixels, q1s
			mov	VSCL, vscl_bporch
			waitvid	metapixels, #%%1

			mov	VSCL, vscl_hsync
			waitvid	metapixels, #%%1133
			mov	VSCL, vscl_blank
			waitvid	metapixels, q1s
			mov	VSCL, vscl_bporch
			waitvid	metapixels, #%%1

			mov	palptr, =@palette_area
			movd	:p_pal, #0
			mov	count, #16
:preblank1
			mov	VSCL, vscl_hsync
			waitvid	metapixels, #%%0022
			mov	VSCL, vscl_blank
			waitvid	metapixels, #0

			mov	pcount, #16
:pallp			rdbyte	r1, palptr
			shl	r1, #2
			or	r1, #3
:p_pal			mov	000, r1
			add	palptr, #1
			add	:p_pal, d0
			djnz	pcount, #:pallp

			mov	VSCL, vscl_bporch
			waitvid	metapixels, #0
			djnz	count, #:preblank1

			mov	count, p_pre		' 17 or 15
:preblank2
			mov	VSCL, vscl_hsync
			waitvid	metapixels, #%%0022
			mov	VSCL, vscl_blank
			waitvid	metapixels, #0
			mov	VSCL, vscl_bporch
			waitvid	metapixels, #0

			djnz	count, #:preblank2

			mov	ypos, #120

vline
			' Sample a rasterline.

			mov	VSCL, vscl_hsync
			waitvid	metapixels, #%%0022
			waitvid	metapixels, q3s
			mov	VSCL, vscl_detach
			waitvid	metapixels, q3s

			' We've got 4048 cycles.

			movd	:p_st, #rasterline - 1
			mov	count, #60
:sample
			movs	:p_1, INA
:p_st			mov	rasterline, r1
:p_1			mov	r1, 000
			add	:p_st, d0
			movs	:p_2, INA
			shl	r1, #8
:p_2			or	r1, 000
			nop
			movs	:p_3, INA
			shl	r1, #8
:p_3			or	r1, 000
			nop
			movs	:p_4, INA
			shl	r1, #8
:p_4			or	r1, 000
			djnz	count, #:sample

			mov	rasterline+59, r1

			' Generate a scanline.

			mov	VSCL, vscl_hsync
			waitvid	metapixels, #%%0022

			mov	VSCL, vscl_visible
			movd	:lp1, #rasterline
			mov	count, #60

:lp1			waitvid	000, #%%0123
			add	:lp1, d0

			djnz	count, #:lp1

			mov	VSCL, vscl_bporch
			waitvid	metapixels, #0

			' Generate a scanline.

			mov	VSCL, vscl_hsync
			waitvid	metapixels, #%%0022

			mov	VSCL, vscl_visible
			movd	:lp2, #rasterline
			mov	count, #60

:lp2			waitvid	000, #%%0123
			add	:lp2, d0

			djnz	count, #:lp2

			mov	VSCL, vscl_bporch
			waitvid	metapixels, #0

			djnz	ypos, #vline

			mov	count, p_post		' 10 or 12
:postblank
			mov	VSCL, vscl_hsync
			waitvid	metapixels, #%%22
			mov	VSCL, vscl_blank
			waitvid	metapixels, #0
			mov	VSCL, vscl_bporch
			waitvid	metapixels, #0

			djnz	count, #:postblank

			jmp	#field


p_pre			long	17
p_post			long	10

vscl_hsync		long	((152) << 12) | (512)	' 2 hsync metapixels, then black
vscl_visible		long	((8) << 12) | (32)	' hsync + 60 * visible + bporch is one line
vscl_bporch		long	((0) << 12) | (108)
vscl_blank		long	((0) << 12) | (1920)	' hsync + blank + bporch is one line
vscl_detach		long	((0) << 12) | (4056)	' hsync + hsync + detach is two lines

metapixels		long	$00_01_02_03		' hsync+vsync, hsync, vsync, black

q1s			long	%%1111111111111111
q3s			long	%%3333333333333333

d0			long	1 << 9

			pool

ypos			res	1
count			res	1
r1			res	1

palptr			res	1
pcount			res	1

sync			res	1

			res	1			' Dummy word before rasterline
rasterline		res	60

			vfit	496
