			include "propeller.i"
			include "demo.i"

PINMASK		=	$03
BORDER		=	$02

			org	0

			mov	DIRA, #PINMASK

			rdlong	r1, =@nextvbl
:w			rdlong	r2, =@nextvbl
			cmp	r1, r2			wz
		if_z	jmp	#:w

vbl
			' Display the front buffer

			rdlong	r1, =@nextvbl
			add	r1, =5080+690+16*24

			mov	t1, lfsr			' Fill t1 with random bits
			shr	lfsr, #1		wc	' Run the lfsr
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	t2, lfsr			' Fill t2 with random bits
			shr	lfsr, #1		wc	' Run the lfsr
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	t1b, lfsr			' Fill t1b with random bits
			shr	lfsr, #1		wc	' Run the lfsr
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	t2b, lfsr			' Fill t2b with random bits

			and	t1, =$3f3f3f3f			' Convert t1 to four random numbers in [$00, $3f]
			and	t2, =$3f3f3f3f			' Convert t2 to four random numbers in [$00, $3f]
			and	t1b, =$3f3f3f3f			' Convert t1 to four random numbers in [$00, $3f]
			and	t2b, =$3f3f3f3f			' Convert t2 to four random numbers in [$00, $3f]

			rdword	addr, =@frontbuf
			wrbyte	one, =@internalvbl

			mov	ycount, #47
lineset
			mov	lcount, #5
vline
			waitcnt	r1, =5080

			rdlong	pixels, addr
			mov	p1, pixels
			mov	p1b, pixels
			mov	xcount, #12
xloop
			add	p1, t1				' Add the dither. No overflow between pixels possible.
			shr	p1, #6				' Shift away the dither for handy palette numbers.
			mov	OUTA, p1
			add	p1b, t1b
			shr	p1b, #6
			shr	lfsr, #1		wc	' Run the lfsr
			mov	OUTA, p1b
			mov	p2, pixels
			add	p2, t2				' Add the dither. No overflow between pixels possible.
			shr	p2, #6				' Shift away the dither for handy palette numbers.
			mov	OUTA, p2
			mov	p2b, pixels
			add	p2b, t2b
			shr	p2b, #6
			mov	OUTA, p2b
			shr	p1, #8				' Move to next pixel
			shr	p2, #8				' Move to next pixel
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	OUTA, p1
			shr	p1b, #8
			mov	t1, lfsr			' Fill t1 with random bits
			and	t1, =$3f3f3f3f			' Convert t1 to four random numbers in [$00, $3f]
			mov	OUTA, p1b
			shr	lfsr, #1		wc	' Run the lfsr
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	t1b, lfsr			' Fill t1b with random bits
			mov	OUTA, p2
			and	t1b, =$3f3f3f3f			' Convert t1b to four random numbers in [$00, $3f]
			shr	p2b, #8
			shr	lfsr, #1		wc	' Run the lfsr
			mov	OUTA, p2b
			shr	p1, #8				' Move to next pixel
			shr	p2, #8				' Move to next pixel
		if_c	xor	lfsr, taps			' Run the lfsr
			mov	OUTA, p1
			shr	p1b, #8
			mov	t2, lfsr			' Fill t2 with random bits
			and	t2, =$3f3f3f3f			' Convert t2 to four random numbers in [$00, $3f]
			mov	OUTA, p1b
			shr	lfsr, #1		wc	' Run the lfsr
		if_c	xor	lfsr, taps			' Run the lfsr
			nop
			mov	OUTA, p2
			shr	p2b, #8
			mov	t2b, lfsr			' Fill t2b with random bits
			and	t2b, =$3f3f3f3f			' Convert t2b to four random numbers in [$00, $3f]
			nop
			mov	OUTA, p2b
			shr	p1, #8				' Move to next pixel
			shr	p2, #8				' Move to next pixel
			add	addr, #4
			mov	OUTA, p1
			shr	p1b, #8
			nop
			nop
			mov	OUTA, p1b
			rdlong	pixels, addr
			mov	p1, pixels
			mov	OUTA, p2
			mov	p1b, pixels
			shr	p2b, #8
			nop
			mov	OUTA, p2b
			djnz	xcount, #xloop

			sub	addr, #48
			mov	OUTA, #0
			djnz	lcount, #vline

			add	addr, #48
			djnz	ycount, #lineset

			jmp	#vbl

one			long	1
lfsr			long	1
taps			long	$c0000031

			pool

r1			res	1
r2			res	1
xcount			res	1
ycount			res	1
lcount			res	1
addr			res	1
pixels			res	1
t1			res	1
t2			res	1
p1			res	1
p2			res	1
t1b			res	1
t2b			res	1
p1b			res	1
p2b			res	1

			vfit	496
