			include "propeller.i"
			include "demo.i"

			org	0
EXITTIME		=	400

			mov	DIRA, #$fc

			rdlong	r1, =@nextvbl
:w			rdlong	r2, =@nextvbl
			cmp	r1, r2		wz
		if_z	jmp	#:w

vbl
			add	frame, #1

			mov	sin_a, frame
			shl	sin_a, #5
			max	sin_a, =$800
			call	#sin

			neg	t1, =$a00
			shr	mulu_x, #5
			add	t1, mulu_x
			shr	mulu_x, #2
			add	t1, mulu_x

			mov	sin_a, frame
			sub	sin_a, =EXITTIME	wc
		if_c	jmp	#:skip
			shl	sin_a, #5
			max	sin_a, =$800
			call	#cos

			mov	t1, =$a00
			shr	mulu_x, #5
			sub	t1, mulu_x
			shr	mulu_x, #2
			sub	t1, mulu_x
:skip
			rdlong	r1, =@nextvbl
			add	r1, =0*5080+690

			add	r1, t1

			mov	animoffset, #0

			mov	sin_a, frame
			shl	sin_a, #4
			sub	sin_a, =$800
			call	#sin
			negnz	zoom, mulu_x
			sar	zoom, #9
			add	zoom, #128

			mov	sin_a, frame
			shl	sin_a, #5
			call	#cos
			negnz	sinerate, mulu_x
			sar	sinerate, #10

			mov	mulu_s, zoom
			mov	mulu_x, #102
			call	#mulu
			mov	minwidth, mulu_s
			shr	minwidth, #8
			add	minwidth, #1

			mov	t1, #102
			sub	t1, minwidth
			shl	zoom, #1
			add	zoom, #20
			max	zoom, t1

			mov	sin_a, frame
			shl	sin_a, #7

			mov	ycount, #240
vline
			add	sin_a, sinerate
			call	#sin

			mov	mulu_s, zoom
			call	#mulu

			negnz	width, mulu_s
			sar	width, #12 + 8		' in [-16, 15]
			add	width, #16

			add	width, minwidth

			neg	prewidth, width
			add	prewidth, #120

			mov	divu_n, =$ff00
			mov	divu_d, width
			call	#divu
			movi	stridelo, divu_n
			ror	divu_n, #9
			mov	stridehi, divu_n
			shl	stridelo, #1		wc
			rcl	stridehi, #1

			' The horizontal texture is stored in 256 bytes of memory. Each byte represents:
			' ssssmm00, s = palette coordinate, mm = mode
			' Mode 00: Transparent - not used in the texture; applies when OUTA is 0.
			' Mode 01: Dark.
			' Mode 10: Normal.
			' Mode 11: Light.
			' Colour cycling will be used to animate the texture.

			mov	addr, =@extra_area
			mov	addrlo, #0

			waitcnt	r1, =5080
pre
			rdbyte	t1, #0			' Align with hub
			djnz	prewidth, #pre
twirl
			rdbyte	t1, addr
			add	t1, animoffset
			add	addrlo, stridelo	wc
			addx	addr, stridehi
			mov	OUTA, t1
			djnz	width, #twirl

			mov	OUTA, #0
			test	ycount, #3	wz
		if_z	add	animoffset, #$10
			djnz	ycount, #vline

			mov	addr, =@palette_area
			rdlong	origpal, =@palette_area

			mov	count, #16
cycle
			mov	t1, cyclebits
			and	t1, =3 << 9
			add	:p_1, t1
			add	:p_2, t1

			wrlong	origpal, addr
			add	:p_3, t1
			add	addr, #4
:p_1			wrlong	darktable, addr
			sub	:p_1, t1
			add	addr, #4
:p_2			wrlong	normaltable, addr
			sub	:p_2, t1
			add	addr, #4
:p_3			wrlong	brighttable, addr
			sub	:p_3, t1
			add	addr, #4

			rol	cyclebits, #2
			djnz	count, #cycle

			rol	cyclebits, #2
			test	frame, #1		wz
		if_z	rol	cyclebits, #2

			jmp	#vbl

divu			shl	divu_d, #15
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, =$ffff
divu_ret		ret

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

			' |sin(sin_a[12..0])| -> sin_a[15..0], (sin(sin_a[12..0]) >= 0) -> z

cos			add	sin_a, =$0800
sin			mov	sin_addr, sin_a
			test	sin_addr, =$0800	wc
			test	sin_addr, =$1000	wz
			and	sin_addr, =$07ff
		if_c	xor	sin_addr, =$07ff
			shl	sin_addr, #1
			or	sin_addr, =$e000
			rdword	mulu_x, sin_addr
cos_ret
sin_ret			ret

darktable		long	%%0000_0000_0000_0000
			long	%%0001_0001_0001_0001
			long	%%0003_0003_0003_0003
			long	%%0113_0113_0113_0113

normaltable		long	%%0001_0001_0001_0001
			long	%%0003_0003_0003_0003
			long	%%0113_0113_0113_0113
			long	%%0333_0333_0333_0333

brighttable		long	%%0113_0113_0113_0113
			long	%%0113_0113_0113_0113
			long	%%0333_0333_0333_0333
			long	%%0333_0333_0333_0333

cyclebits		long	%%0000012333333210 << 1

			pool

frame			long	0

r1			res	1
r2			res	1
t1			res	1
count			res	1
ycount			res	1
addr			res	1
addrlo			res	1
stridehi		res	1
stridelo		res	1
width			res	1
prewidth		res	1
origpal			res	1
animoffset		res	1
sinerate		res	1
zoom			res	1
minwidth		res	1
xoffset			res	1

sin_a			res	1
sin_addr		res	1

mulu_s			res	1
mulu_x			res	1

divu_n			res	1
divu_d			res	1

			vfit	496
