			include "propeller.i"
			include "demo.i"

			org	0
FOSTART			=	21800

			mov	t1, #DITHER_VOXEL
			wrbyte	t1, =@ditherstyle

			mov	addr, =16 * 16 - 4
:seedlp
			shr	lfsr, #1		wc
		if_c	xor	lfsr, taps
			wrlong	lfsr, addr
			sub	addr, #4		wc
		if_nc	jmp	#:seedlp

loop
			' Fetch a new job (column to render).

:lock			lockset	zero			wc
		if_c	jmp	#:lock
			rdword	xdisp, =@nextline
			rdword	coladdr, =@backbuf
			mov	t1, xdisp
			add	t1, #1
			wrword	t1, =@nextline
			lockclr	zero

			cmp	xdisp, #120		wc wz
		if_b	jmp	#:doline

			' The frame is complete. Wait for the next one.

:wait			lockset	zero			wc
		if_c	jmp	#:wait
			rdword	xdisp, =@nextline
			rdword	coladdr, =@backbuf
			cmp	xdisp, #120		wc wz
		if_b	mov	t1, xdisp
		if_b	add	t1, #1
		if_b	wrword	t1, =@nextline
			lockclr	zero
		if_ae	jmp	#:wait

			' New frame.

			cmp	frame, =FOSTART		wc wz
		if_ae	add	fadetowhite, #2
			sub	fadetowhite, #1
			mins	fadetowhite, #0

			mov	sin_a, frame
			call	#sin
			negnz	mulu_x, mulu_x
			sar	mulu_x, #11
			add	eyeangle, mulu_x

			mov	sin_a, eyeangle
			call	#sin
			shl	mulu_x, #9
			sumz	eyex, mulu_x
			call	#cos
			shl	mulu_x, #9
			sumnz	eyez, mulu_x

			add	frame, #55

			' Draw a column.
:doline
			add	coladdr, xdisp
			mov	x, xdisp
			sub	x, #60
			shl	x, #1

			mov	sin_a, eyeangle
			call	#sin
			negz	eyedirx, mulu_x
			shl	eyedirx, #8
			abs	mulu_s, x		wc
			rcl	signed, #1
			call	#mulu
			shr	signed, #1		wc
		if_c	neg	mulu_s, mulu_s
			negnz	eyedirz, mulu_s
			call	#cos
			mov	t1, mulu_x
			shl	t1, #8
			sumnz	eyedirz, t1
			abs	mulu_s, x		wc
			rcl	signed, #1
			call	#mulu
			shr	signed, #1		wc
		if_c	neg	mulu_s, mulu_s
			sumnz	eyedirx, mulu_s

			mov	ytop, #115

			' x, z are 8.24

			mov	x, eyedirx
			shl	x, #4
			add	x, eyex
			mov	z, eyedirz
			shl	z, #4
			add	z, eyez

			mov	depth, #$10
:depthlp
			add	x, eyedirx
			add	z, eyedirz
			add	x, eyedirx
			add	z, eyedirz

			mov	perlin_t, z
			shr	perlin_t, #12 + 7
			mov	perlin_s, x
			shr	perlin_s, #12 + 7
			call	#readperlin
			shl	perlin_res, #4
			mov	mulu_x, perlin_res
			mov	perlin_t, x
			shr	perlin_t, #11 + 7
			mov	perlin_s, z
			shr	perlin_s, #11 + 7
			call	#readperlin
			shl	perlin_res, #2
			add	mulu_x, perlin_res
			mov	perlin_t, z
			shr	perlin_t, #10 + 7
			mov	perlin_s, x
			shr	perlin_s, #10 + 7
			call	#readperlin
			add	mulu_x, perlin_res

			shr	mulu_x, #1
			mov	mulu_s, mulu_x
			shr	mulu_s, #4
			call	#mulu
			shr	mulu_s, #8

			mov	divu_n, =1300
			sub	divu_n, mulu_s
			abs	divu_n, divu_n		wc
			rcl	signed, #1
			shl	divu_n, #4
			mov	divu_d, #32
			add	divu_d, depth
			call	#divu
			shr	signed, #1		wc
			negc	yproj, divu_n
			add	yproj, #2
			sar	yproj, #2
			add	yproj, #58

			mins	yproj, #0

			cmp	yproj, ytop		wc wz
		if_ae	jmp	#:done

			neg	perlin_t, x
			shr	perlin_t, #9 + 7
			neg	perlin_s, z
			shr	perlin_s, #9 + 7
			call	#readperlin
			shr	perlin_res, #5
			add	perlin_res, depth
			add	perlin_res, fadetowhite
			max	perlin_res, #$30

:fill		
			sub	ytop, #1
			mov	addr, ytop
			shl	addr, #7
			add	addr, coladdr
			wrbyte	perlin_res, addr
			cmp	yproj, ytop		wc wz
		if_b	jmp	#:fill
:done
			add	depth, #1
			cmp	depth, #$30		wz
		if_ne	jmp	#:depthlp

			mov	x, eyedirx
			shl	x, #3
			add	x, eyex
			mov	z, eyedirz
			shl	z, #3
			add	z, eyez

			mov	yproj, #0
			mov	dx, eyedirx
			mov	dz, eyedirz

:sky			cmp	yproj, ytop		wc wz
		if_ae	jmp	#loop

			mov	t1, #$40
			cmp	yproj, #$30*2		wc wz
		if_ae	jmp	#:white

			add	x, dx
			mov	t1, eyedirx
			sar	t1, #5
			add	dx, t1
			add	z, dz
			mov	t1, eyedirz
			sar	t1, #5
			add	dz, t1

			mov	perlin_t, x
			shr	perlin_t, #10 + 7
			mov	perlin_s, z
			shr	perlin_s, #10 + 7
			call	#readperlin
			shr	perlin_res, #3

			neg	t1, yproj
			sar	t1, #1
			add	t1, perlin_res
			add	t1, #$40
			sub	t1, fadetowhite
			mins	t1, #$40
:white
			mov	addr, yproj
			shl	addr, #7
			add	addr, coladdr
			wrbyte	t1, addr

			add	yproj, #1
			jmp	#:sky

readperlin
			movi	perl_t_frac, perlin_t
			movi	perl_s_frac, perlin_s
			shr	perlin_t, #9
			shr	perlin_s, #9 - 4
			and	perlin_t, #$07
			and	perlin_s, #$70
			or	perlin_s, perlin_t
			rdbyte	perlin_res, perlin_s		' x0, y0
			add	perlin_s, #$10
			and	perlin_s, #$77
			rdbyte	mulu_s, perlin_s		' x1, y0
			sub	mulu_s, perlin_res

			abs	mulu_s, mulu_s		wc
			muxc	mulu_s, =1 << 8

			shr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc	' sign bit
			shr	mulu_s, #8 + 7

			shl	perlin_res, #9
			sumc	perlin_res, mulu_s

			' perlin_res is weighted sum of x0, y0 and x1, y1 in 23.9 format

			add	perlin_s, #$01
			and	perlin_s, #$77
			'nop
			rdbyte	mulu_s, perlin_s		' x1, y1
			sub	perlin_s, #$10
			and	perlin_s, #$77
			rdbyte	t1, perlin_s			' x0, y1

			sub	mulu_s, t1

			abs	mulu_s, mulu_s		wc
			muxc	mulu_s, =1 << 8

			shr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_s_frac	wc
			rcr	mulu_s, #1		wc	' sign bit
			shr	mulu_s, #8 + 7

			shl	t1, #9
			sumc	t1, mulu_s

			' t1 is weighted sum of x0, y1 and x1, y1 in 23.9 format

			sub	t1, perlin_res
			sar	t1, #9

			abs	mulu_s, t1		wc
			muxc	mulu_s, =1 << 8

			shr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, perl_t_frac	wc
			rcr	mulu_s, #1		wc	' sign bit
			shr	mulu_s, #8 + 7

			sumc	perlin_res, mulu_s
			shr	perlin_res, #9
readperlin_ret		ret

divu			shl	divu_d, #15
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, =$ffff
divu_ret		ret

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

			' |sin(sin_a[12..0])| -> sin_a[15..0], (sin(sin_a[12..0]) >= 0) -> z

cos			add	sin_a, =$0800
sin			mov	sin_addr, sin_a
			test	sin_addr, =$0800	wc
			test	sin_addr, =$1000	wz
			and	sin_addr, =$07ff
		if_c	xor	sin_addr, =$07ff
			shl	sin_addr, #1
			or	sin_addr, =$e000
			rdword	mulu_x, sin_addr
cos_ret
sin_ret			ret

lfsr			long	$12b45a76
taps			long	$c0000031

fadetowhite		long	$20

eyeangle		long	$800
eyex			long	0
eyez			long	0

frame			long	0
perl_s_frac		long	0
perl_t_frac		long	0

			pool

t1			res	1
t2			res	1
addr			res	1
coladdr			res	1
count			res	1
ycount			res	1
xdisp			res	1
x			res	1
z			res	1
dx			res	1
dz			res	1
step			res	1
depth			res	1
ytop			res	1
yproj			res	1

eyedirx			res	1
eyedirz			res	1

perlin_s		res	1
perlin_t		res	1
perlin_res		res	1

sin_a			res	1
sin_addr		res	1

mulu_s			res	1
mulu_x			res	1
signed			res	1

divu_d			res	1
divu_n			res	1

			vfit	496
