			include "propeller.i"
			include "demo.i"

			org	0

COLORFLIP		=	$10
FOSTART			=	320

			wrbyte	zero, =@ditherstyle
			wrlong	frontback, =@backbuf
loop
			add	zanim, =$21000
			add	tanim, =$0019
			add	banim, =$0013
			add	fadeanim, #1
			mov	fadetowhite, fadeanim
			sub	fadetowhite, =FOSTART
			mins	fadetowhite, #0

			mov	fade, #0
			cmp	fadeanim, #$30		wc wz
		if_b	neg	fade, fadeanim
		if_b	add	fade, #$30

			test	zanim, =$80000	wz

	if_nz		xor	colour1, #COLORFLIP
	if_nz		ror	lightbits, #3

			and	zanim, =$7ffff

			mov	cmd, #RAST_CLEAR
			call	#rastercall

			mov	sin_a, tanim
			call	#sin
			negnz	tilt, sin_res
			sar	tilt, #6

			mov	innerlight, lightbits

			mov	zcount, #14
			mov	currz, =$00500000
			sub	currz, zanim
zloop
			mov	last_z, currz
			sub	currz, =$00080000

			mov	sin_a, =1<<9
			add	sin_a, tilt
			call	#sincos
			shl	sin_sin, #3
			shl	sin_cos, #3

			xor	colour1, #COLORFLIP

			mov	light, =$00020001
			rol	light, innerlight

			mov	count, #16
iloop
			mov	last_sin, sin_sin
			mov	last_cos, sin_cos

			mov	sin_a, count
			shl	sin_a, #9
			add	sin_a, tilt
			call	#sincos
			shl	sin_sin, #3
			shl	sin_cos, #3

			' Draw a quad between (sin_cos, sin_sin, currz)
			' and (last_cos, last_sin, last_z).

			mov	addr, =@rast_x1

			call	#waitraster

			cmp	count, #6	wz
		if_z	sub	count, #3

			cmp	count, #2	wz
		if_nz	xor	colour1, #COLORFLIP

			mov	t1, colour1
			ror	light, #1	wc
		if_c	mov	t1, #$d8
		if_c	sub	t1, fade
		if_c	min	t1, #$c7

		if_z	mov	t1, #$1e

			sub	t1, zcount
			sub	t1, zcount
			sub	t1, zcount
			sub	t1, zcount
			sub	t1, fade
			mins	t1, #0
			cmp	t1, #$40	wc wz
			add	t1, fadetowhite
		if_be	max	t1, #$40
		if_a	max	t1, #$c0
			wrbyte	t1, =@rast_colour

			mov	x, sin_cos
			mov	y, sin_sin
			mov	z, currz
			call	#project

			mov	x, last_cos
			mov	y, last_sin
			mov	z, currz
			call	#project

			mov	x, last_cos
			mov	y, last_sin
			mov	z, last_z
			call	#project

			mov	x, sin_cos
			mov	y, sin_sin
			mov	z, last_z
			call	#project

			mov	cmd, #RAST_QUAD
			call	#rastercall

			djnz	count, #iloop

			rol	innerlight, #3

			djnz	zcount, #zloop

			mov	cmd, #RAST_GLOW
			call	#rastercall

			call	#waitraster

			' swap buffers
			rol	frontback, #16
			wrlong	frontback, =@backbuf
			wrbyte	zero, =@internalvbl
:wvbl			rdbyte	t1, =@internalvbl
			tjz	t1, #:wvbl

			jmp	#loop

			' Input: x, y, z as 16.16 in [-128.0, 128.0[
			' Output: x, y as 8.8 in [-128.0, 128.0[
project
			' Bend the tunnel by adding an x offset which
			' varies with z * z * curvature.

			mov	mulu_s, z
			sar	mulu_s, #15
			add	mulu_s, =$0020
			mins	mulu_s, #0
			mov	mulu_x, mulu_s
			call	#mulu
			mov	mulu_x, mulu_s
			mov	sin_a, banim
			call	#sin
			mov	mulu_s, sin_res
			shr	mulu_s, #9
			call	#mulu
			sumnz	x, mulu_s

			sar	z, #14			' fov
			add	z, =$00b4		' zoom

			mov	divu_n, x
			sar	x, #2
			sub	divu_n, x
			mov	divu_d, z
			call	#divs
			wrword	divu_n, addr
			add	addr, #2
			mov	divu_n, y
			mov	divu_d, z
			call	#divs
			wrword	divu_n, addr
			add	addr, #2
project_ret		ret

waitraster
:wait			rdbyte	t1, =@rastercmd
			tjnz	t1, #:wait
waitraster_ret		ret

rastercall
			call	#waitraster
			wrbyte	cmd, =@rastercmd
rastercall_ret		ret

divs
			abs	divu_d, divu_d		wc
			rcl	signed, #1
			abs	divu_n, divu_n		wc
		if_c	xor	signed, #1
			call	#divu
			rcr	signed, #1		wc
			negc	divu_n, divu_n
divs_ret		ret

divu			shl	divu_d, #15
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, =$ffff
divu_ret		ret

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

sincos
			call	#sin
			negnz	sin_sin, sin_res
			call	#cos
			negnz	sin_cos, sin_res
sincos_ret		ret

			' |sin(sin_a[12..0])| -> sin_a[15..0], (sin(sin_a[12..0]) >= 0) -> z

cos			add	sin_a, =$0800
sin			mov	sin_addr, sin_a
			test	sin_addr, =$0800	wc
			test	sin_addr, =$1000	wz
			and	sin_addr, =$07ff
		if_c	xor	sin_addr, =$07ff
			shl	sin_addr, #1
			or	sin_addr, =$e000
			rdword	sin_res, sin_addr
cos_ret
sin_ret			ret

frontback		word	@graphics0, @graphics1

colour1			long	$20

lightbits		long	$abc9117e

zanim			long	0
tanim			long	0
banim			long	0
fadeanim		long	0

			pool

x			res	1
y			res	1
z			res	1

currz			res	1
last_z			res	1
last_cos		res	1
last_sin		res	1

tilt			res	1

cmd			res	1
t1			res	1
addr			res	1
count			res	1
zcount			res	1

divu_n			res	1
divu_d			res	1
signed			res	1

mulu_s			res	1
mulu_x			res	1

sin_a			res	1
sin_res			res	1
sin_sin			res	1
sin_cos			res	1
sin_addr		res	1

light			res	1
innerlight		res	1

fade			res	1
fadetowhite		res	1

			vfit	496
